/**************************************************************************/
/*                                                                        */
/* Copyright (c) 2001, 2011 NoMachine, http://www.nomachine.com/.         */
/*                                                                        */
/* NXMANAGER, NX protocol compression and NX extensions to this software  */
/* are copyright of NoMachine. Redistribution and use of the present      */
/* software is allowed according to terms specified in the file LICENSE   */
/* which comes in the source distribution.                                */
/*                                                                        */
/* Check http://www.nomachine.com/licensing.html for applicability.       */
/*                                                                        */
/* NX and NoMachine are trademarks of Medialogic S.p.A.                   */
/*                                                                        */
/* All rights reserved.                                                   */
/*                                                                        */
/**************************************************************************/

/*
Dynamic buttons

HTML:
<!-- Session Button-->
     <td width="79"><A HREF="?page=body&action=sessionList"
      TARGET="bodyFrame"
      ALT="session list"
      TITLE="Session list"
      onMouseOver="setImage('img_big_session', 'over' )"
      onMouseOut="setImage('img_big_session', 'out' )"
      onClick="">
      <img id="img_big_session"
           width="79"
           height="57"
           border="0"
           src_normal=""
           src_over=""
           src_pressed=""
           src_actual=""
           src_disabled=""
           src="<TMPL_VAR NAME="images_uri_toolbar">/butt4.gif" ></a></td>

From bodyFrame:
pressImage('img_big_session', 'butt5.gif')

  API

- setImage('img_big_session', 'normal')
- setImage( identificativo, status )

  CASE status == normal
   1. search its tag id
   2. set its src to the value inserted in src_normal

  CASE status == over
   1. search its tag id
   2. remember the actual image in src_orig (copy src in src_orig)
   2. set its src to the value inserted in src_over
      (this go to skip if it's into status actual)

  CASE status == out
   1. search its tag id
   2. reset src to the preview value (from src_orig to src)

  CASE status == actual
   1. search its tag id
   2. set its src to the value inserted in src_actual
   3. set all others images to src_normal

  CASE status == disabled
   1. search its tag id
   2. set its src to the value inserted in src_disabled

*/

// change the img status, and change its image accordingly to its status
// sGroup can be empty, if it's set, it affects only the group images
// ie. if sGroup is set, status 'actual' does not try to restore images outside the group
function setImage( sId, sStatus, sGroup)
{
  var oTag = document.getElementById( sId );
  if (!oTag) return 0;

  if (sStatus == 'normal')
  {
    // oTag.src = oTag.src_normal;
    oTag.setAttribute('src', oTag.getAttribute('src_normal'));
    oTag.setAttribute('src_orig',  oTag.getAttribute('src_normal'));

    // this is to enable the parent node href
    // (works if a,img tags are consecutive <a href="..."><img ... /></a> )
    if (oTag.parentNode.getAttribute('NOhref'))
    {
      oTag.parentNode.setAttribute('href', oTag.parentNode.getAttribute('NOhref'));
      oTag.parentNode.removeAttribute('NOhref');
    }
  }

  if (sStatus == 'over')
  {
    oTag.setAttribute('src_orig',  oTag.getAttribute('src'));

    if (   ( baseName(oTag.getAttribute('src')) != baseName(oTag.getAttribute('src_actual')) )
        && ( baseName(oTag.getAttribute('src')) != baseName(oTag.getAttribute('src_disabled')) ))
    {
      oTag.setAttribute('src', oTag.getAttribute('src_over'));
    }
  }

  if (sStatus == 'out')
  {
    oTag.setAttribute('src',  oTag.getAttribute('src_orig'));
  }

  if (sStatus == 'actual')
  {
    restoreAllImagesFromActualStatus();

    oTag.setAttribute('src', oTag.getAttribute('src_actual'));
    oTag.setAttribute('src_orig', oTag.getAttribute('src_actual'));

    // This is used when the toolbar is reloaded by nop action
    // it must remember which image is actual
    actualImage = sId;
  }

  if (sStatus == 'actual_plus')
  {
    oTag.setAttribute('src', oTag.getAttribute('src_actual'));
    oTag.setAttribute('src_orig', oTag.getAttribute('src_actual'));
  }

  if (sStatus == 'disabled')
  {
    oTag.setAttribute('src', oTag.getAttribute('src_disabled'));

    // this is to disable the parent node href  (works if <a href="..."><img ... /></a> )
    if (oTag.parentNode.getAttribute('href'))
    {
      oTag.parentNode.setAttribute('NOhref', oTag.parentNode.getAttribute('href'));
      oTag.parentNode.removeAttribute('href');
    }
  }
}


// same as setImage but affecting *every* images of the specified group, ie:
// change the img status of every images having specified group attribute,
// and change the images accordingly to their status
function setGroupImages( sGroup, sStatus )
{
  var imgNodeList = document.getElementsByTagName('img');
  for (i = 0; i < imgNodeList.length ; i++)
  {
    if (imgNodeList.item(i) && ( imgNodeList.item(i).getAttribute('group') == sGroup ))
    {
      setImage(imgNodeList.item(i).getAttribute('id'), sStatus, sGroup);
    }
  }

  if (sGroup == "server" && sStatus == "normal")
  {
    actualImage = "";
  }
}


// restore all images that are "pressed" (ie in 'actual' status)
// into normal status
// this is expecially useful for ...
function OLD_restoreAllImagesFromActualStatus()
{
  var imgNodeList = document.getElementsByTagName('img');
  for (i = 0; i < imgNodeList.length ; i++)
  {
    if (     imgNodeList.item(i)
         && ( imgNodeList.item(i).getAttribute('src') ==
              imgNodeList.item(i).getAttribute('src_actual') ) )
    {
      imgNodeList.item(i).setAttribute('src', imgNodeList.item(i).getAttribute('src_normal') );
      imgNodeList.item(i).setAttribute('src_orig', imgNodeList.item(i).getAttribute('src_normal') );
    }
  }
}


// restore all images that are "pressed" (ie in 'actual' status)
// into normal status
// this is expecially useful for ...
function restoreAllImagesFromActualStatus()
{
  var imgNodeList = document.getElementsByTagName('img');
  for (i = 0; i < imgNodeList.length ; i++)
  {
    if (  imgNodeList.item(i) )
    {
      var aPartsSrc = imgNodeList.item(i).getAttribute('src').split("/");
      var sBaseSrc = '';
      if (aPartsSrc.length > 1)
      {
        sBaseSrc = aPartsSrc[aPartsSrc.length -1];
      }
      else
      {
        sBaseSrc = aPartsSrc;
      }

      var sBaseSrcActual = '';
      if (imgNodeList.item(i).getAttribute('src_actual'))
      {
        var aPartsSrcActual = imgNodeList.item(i).getAttribute('src_actual').split("/");
        if (aPartsSrcActual.length > 1)
        {
          sBaseSrcActual = aPartsSrcActual[ aPartsSrcActual.length -1 ];
        }
        else
        {
          sBaseSrcActual = aPartsSrcActual;
        }
      }

      if ( sBaseSrc ==  sBaseSrcActual )
      {
        imgNodeList.item(i).setAttribute('src', imgNodeList.item(i).getAttribute('src_normal') );
        imgNodeList.item(i).setAttribute('src_orig', imgNodeList.item(i).getAttribute('src_normal') );
      }
    }
  }
}


// reset to normal status  all the images having specified attribute group
function resetGroupImages( sGroup )
{
  var imgNodeList = document.getElementsByTagName('img');
  for (i = 0; i < imgNodeList.length ; i++)
  {
    if (    ( imgNodeList.item(i) )
            && ( imgNodeList.item(i).getAttribute('group') == sGroup ) )
    {
      imgNodeList.item(i).setAttribute('src', imgNodeList.item(i).getAttribute('src_normal') );

      imgNodeList.item(i).setAttribute('src_orig', imgNodeList.item(i).getAttribute('src_normal') );
    }
  }
}


function resetAllImages()
{
  var imgNodeList = document.getElementsByTagName('img');
  for (i = 0; i < imgNodeList.length ; i++)
  {
    if (( imgNodeList.item(i) )
        && ( imgNodeList.item(i).getAttribute('src_normal') ) )
    {
      var oTag = imgNodeList.item(i);
      oTag.setAttribute('src', imgNodeList.item(i).getAttribute('src_normal') );
      oTag.setAttribute('src_orig', imgNodeList.item(i).getAttribute('src_normal') );

      // this is to enable the parent node href  (works if <a href="..."><img ... /></a> )
      if (oTag.parentNode.getAttribute('NOhref'))
      {
        oTag.parentNode.setAttribute('href', oTag.parentNode.getAttribute('NOhref'));
        oTag.parentNode.removeAttribute('NOhref');
      }
    }
  }
}

function baseName( sPath )
{
  var osPath = new String(sPath);
  var aParts = osPath.split("/");
  var sBase = '';
  if (aParts.length > 1)
  {
    sBase = aParts[ aParts.length -1 ];
  } else {
    sBase = aParts;
  }
  return sBase;
}


/* Hide all images that have the specified attribute group="sClassname" */
function makeClassInvisible( sClassname )
{
  var imgNodeList = document.getElementsByTagName('img');
  for (i = 0; i < imgNodeList.length ; i++)
  {
    if (   ( imgNodeList.item(i) )
        && ( imgNodeList.item(i).getAttribute('group') == sClassname ) )
    {
      imgNodeList.item(i).style.display = 'none';
    }
  }
}


/* Unhide all images that have the specified attribute group="sClassname" */
function makeClassVisible( sClassname )
{
  var imgNodeList = document.getElementsByTagName('img');
  for (i = 0; i < imgNodeList.length ; i++)
  {
    if (   ( imgNodeList.item(i) )
        && ( imgNodeList.item(i).getAttribute('group') == sClassname ) )
    {
      imgNodeList.item(i).style.display = 'block';
    }
  }
}


function submitForm(sFormName, sOp )
{

}
