/**************************************************************************/
/*                                                                        */
/* Copyright (c) 2001, 2011 NoMachine, http://www.nomachine.com/.         */
/*                                                                        */
/* NXMANAGER, NX protocol compression and NX extensions to this software  */
/* are copyright of NoMachine. Redistribution and use of the present      */
/* software is allowed according to terms specified in the file LICENSE   */
/* which comes in the source distribution.                                */
/*                                                                        */
/* Check http://www.nomachine.com/licensing.html for applicability.       */
/*                                                                        */
/* NX and NoMachine are trademarks of Medialogic S.p.A.                   */
/*                                                                        */
/* All rights reserved.                                                   */
/*                                                                        */
/**************************************************************************/

/************************/
/* Begin Global Objects */
/************************/
var globalRootNode = null; // It's the root node used for search nodes in getNodeById
var globalNXTree   = null; // It's the NXTree used for the display prototype

var globalCookie     = "";

var menuCounter      = 0;
var menuServer       = new Array();
var menuUsers        = new Array();
var menuSessions     = new Array();
var menuNodes        = new Array();
var menuConfServer   = new Array();
var menuConfNXServer = new Array();
var menuConfNXNode   = new Array();

var menuStatistics   = new Array();

var sessionPrevPage  = new Array();
var sessionNextPage  = new Array();

var nodePrevPage     = new Array();
var nodeNextPage     = new Array();

var userPrevPage     = new Array();
var userNextPage     = new Array();

var menuProfiles    = new Array();

var displayCounter = 0; // to delete


function resetcounter(){
 displayCounter=0;
}

/**********************/
/* End Global Objects */
/**********************/


/********************************************/
/* Begin Configuration And Default Settings */
/********************************************/
var NXTreeSettings =
{
  nodeTitle           : '',
  nodeUri             : '',
  nodeTarget          : 'bodyFrame',

  // node icons
  nodeIconUriPath     : '/nxmanager/images/menu/',
  rootIcon            : 'home.gif',
  rootIconOpen        : 'home.gif',
  nodeIcon            : 'node1.gif',
  nodeIconOpen        : 'node2.gif',
  nodeIconDisabled    : 'node1_dsb.gif',   //v14

  // tree icons
  treeIconUriPath     : '/nxmanager/images/tree/',
  treeIconRoot        : 'empty_.gif',
  treeIconRootMinus   : 'minus_.gif',
  treeIconRootPlus    : 'plus_.gif',
  treeIconBlank       : 'empty.gif',
  treeIconTBlank      : 'emptyT.gif',
  treeIconLBlank      : 'emptyL.gif',
  treeIconI           : 'i.gif',
  treeIconT           : 'T.gif',
  treeIconL           : 'L.gif',
  treeIconTplus       : 'plusT.gif',
  treeIconTminus      : 'minusT.gif',
  treeIconLplus       : 'plusL.gif',
  treeIconLminus      : 'minusL.gif',

  // tree icon dimensions
  treeIconWidth       : "16px",
  treeIconHeight      : "16px"
};
/******************************************/
/* End Configuration And Default Settings */
/******************************************/


/*********************/
/* Begin Object Tree */
/*********************/
function NXTree()
{
  this.NXRootNode = null;
  globalNXTree = this;
};
/*******************/
/* End Object Tree */
/*******************/


/**************************/
/* Begin Object Tree Node */
/**************************/
function NXTreeNode(sTitle, sUri, sIcon, sIconOpen, sDesc, sTarget, sIconDisabled)
{
  this.sId        = '0';

  this.sTitle     = sTitle || NXTreeSettings.nodeTitle;
  this.sUri       = sUri   || NXTreeSettings.nodeUri;
  this.sTarget    = sTarget|| NXTreeSettings.nodeTarget;
  this.sDesc      = sDesc;

  this.sIcon      = sIcon     || NXTreeSettings.nodeIcon;
  this.sIconOpen  = sIconOpen || NXTreeSettings.nodeIconOpen;
  this.sIconDisabled  = sIconDisabled || NXTreeSettings.nodeIconDisabled; //v14 TODO

  this.oParentNode   = null;
  this.aChildNodes   = [];

  this.bFocus       = false;
  this.bDisabled    = false;
  this.bLinkable    = false;
  this.bIsLast      = true;
  this.bHasChildren = false;

  this.sCallbackEvalExpand = "parent.bodyFrame.document.location = '" + this.sUri +"';";

  return this;
};
/************************/
/* End Object Tree Node */
/************************/


/***************************/
/* Begin NXTree Prototypes */
/***************************/
NXTree.prototype.setRootNode = function(rootNode)
{
  this.NXRootNode = rootNode;
  globalRootNode = rootNode;
};

NXTree.prototype.display = function()
{
  var htmlTree = this.NXRootNode.toString();
  changeContent('NXManagerTree', htmlTree);

  //alert("Set cookie with " + globalCookie);
  //setCookie('menu',globalCookie);
  globalCookie = "";
  
  displayCounter++;
  ////alert(displayCounter);

};
/*************************/
/* End NXTree Prototypes */
/*************************/


/*******************************/
/* Begin NXTreeNode Prototypes */
/*******************************/
NXTreeNode.prototype.focus = function()
{
  var oldFocusId = checkCookie("focusId");
  if (oldFocusId && oldFocusId != null)
  {
    oldFocusNode = getNodeById(oldFocusId);
    if (oldFocusNode && oldFocusNode != null)
    {
      oldFocusNode.bFocus = false;
    }
  }

  addCookie("focusId",this.sId);
  this.bFocus = true;

  this.bDisabled = (checkCookie(this.sId+'Status') == 'disabled') ? true : false;

  if (this.bDisabled || !this.aChildNodes.length)
  {
    if (this.oParentNode.aChildNodes.length)
    {
      this.oParentNode.expand();
    }
    else
    {
      globalNXTree.display();
      //alert(displayCounter + ". Focus");
    }
  }
  else
  {
    this.expand();
  }
};

NXTreeNode.prototype.expand = function()
{
  changeTreeIcons(this.sId,"minus");
  if (this.oParentNode && this.oParentNode != null)
  {
    this.oParentNode.expand();
  }
};

NXTreeNode.prototype.reduce = function()
{
  changeTreeIcons(this.sId,"plus");
  globalNXTree.display();
};

NXTreeNode.prototype.enable = function()
{
  this.bDisabled = false;
  addCookie(this.sId+"Disabled","");
  if (this.sId == '0')
  {
    this.expand();
  }
  else
  {
    changeTreeIcons(this.sId,"plus");
  }
};

NXTreeNode.prototype.disable = function(option)
{
  this.bDisabled = true;
  addCookie(this.sId+"Status","disabled");
  addCookie(this.sId+"Disabled","");
  switch (option)
  {
    case "linkable":
      this.bLinkable = true;
      addCookie(this.sId+"Disabled","linkable");
      break;
  }
  globalNXTree.display();
};

NXTreeNode.prototype.enableAllChildren = function()
{
  var oldStatus = '';
  for (var i in this.aChildNodes)
  {
    oldStatus = checkCookie(this.aChildNodes[i].sId+'OldStatus');
    oldStatus = (!oldStatus || oldStatus == null) ? 'plus' : oldStatus;
    addCookie(this.aChildNodes[i].sId+'Status',oldStatus);
    this.aChildNodes[i].bDisabled = false;
    if (this.aChildNodes[i].aChildNodes.length)
    {
      this.aChildNodes[i].enableAllChildren();
    }
  }
}

NXTreeNode.prototype.disableAllChildren = function()
{
  var actualStatus = '';
  for (var i in this.aChildNodes)
  {
    actualStatus = checkCookie(this.aChildNodes[i].sId+'Status');
    actualStatus = (!actualStatus || actualStatus == null) ? 'plus' : actualStatus;
    addCookie(this.aChildNodes[i].sId+'OldStatus',actualStatus);
    addCookie(this.aChildNodes[i].sId+'Status','disabled');
    this.aChildNodes[i].bDisabled = true;
    if (this.aChildNodes[i].aChildNodes.length)
    {
      this.aChildNodes[i].disableAllChildren();
    }
  }
};

NXTreeNode.prototype.removeAllChildren = function()
{
  this.aChildNodes = null;
  this.aChildNodes = [];

  globalNXTree.display();
};

NXTreeNode.prototype.addChild = function(NXChildNode)
{
  var newId = "0";
  if (this.aChildNodes.length)
  {
    newId = ""+this.aChildNodes.length+"";
    this.aChildNodes[this.aChildNodes.length - 1].bIsLast = false;
  }

  this.aChildNodes[newId] = NXChildNode;

  NXChildNode.sId = ""+this.sId+"."+this.aChildNodes.length+"";
  NXChildNode.oParentNode = this;
  

//  ADDCHILD PROCEDURE TEST
//  var win = window.open("", "win", "width=800,height=600,scrollbars=yes"); // a window object
//  win.document.open("text/html", "replace");
//  win.document.write("<table border=1><tr>");
//  win.document.write("<td><pre>" + NXChildNode.oParentNode + "</pre><br> is Child of <br><pre>" + this + "</pre><br>");  
//  win.document.write("<td><textarea rows=20 cols=30>" + NXChildNode.oParentNode + "\n\n\n is Child of \n\n\n" + this + "</textarea><br>");
//  win.document.write("</tr></table><hr>");

};

NXTreeNode.prototype.toString = function()
{
 if (this.bDisabled){
   return this._showRootNode();
 }
 else {
   return this._showRootNode() + this._showNodes();
 }
};

NXTreeNode.prototype._showNodes = function()
{
  // 0 is the sID of root node
  var rootStatus = checkCookie('0Status');
  rootStatus = (!rootStatus || rootStatus == null) ? "plus" : rootStatus;

  var html = '';

  if (rootStatus == 'minus' || rootStatus == 'disabledMinus')
  {
    html = showChildren(this.aChildNodes);
  }

  return html;
};

NXTreeNode.prototype._showRootNode = function()
{
  var rootIcon = checkCookie(this.sId);
  if (!rootIcon || rootIcon == null)
  {
    rootIcon = NXTreeSettings.treeIconRootMinus;
    addCookie(this.sId,rootIcon);
    addCookie(this.sId+'Status','minus');
  }

  var sIcon = this.sIcon;
  var rootStatus = checkCookie(this.sId+'Status');
  if (this.bDisabled || rootStatus == 'disabled' || rootStatus == 'disabledMinus' || rootStatus == 'disabledPlus')
  {
    sIcon = this.sIconDisabled;
    this.bDisabled = true;
    addCookie(this.sId+'Status','disabledPlus');
    if (rootStatus == 'disabled' || rootStatus == 'disabledMinus' || rootStatus == 'minus')
    {
      addCookie(this.sId+'Status','disabledMinus');
    }
  }

  var html = '';

  this.bFocus = (checkCookie("focusId") == this.sId) ? true : false;

  var divClass = (this.bFocus) ? '_focus' : '';
  divClass = (this.bDisabled) ? '_disabled' : divClass;

  html += '<div id="NXTreeRoot" class="NXTN_node'+divClass+'">';

  html += '<img id="'+this.sId+'" class="NXTN_treeIcon"';
  html += 'src="'+NXTreeSettings.treeIconUriPath+''+rootIcon+'" ';
  html += 'width="'+NXTreeSettings.treeIconWidth+'" height="'+NXTreeSettings.treeIconHeight+'"';

  if (this.bDisabled)
  {
    //html += ' onclick="changeRootIconsDisabled(this.id)"';
  }
  else
  {
    html += ' onclick="changeTreeIcons(this.id)"';
  }

  html += '/>';

  html += '<img id="NXTN-img-1-nodeIcon" class="NXTN_nodeIcon"';
  html += 'src="'+NXTreeSettings.nodeIconUriPath+''+sIcon+'" ';
  html += 'width="'+NXTreeSettings.treeIconWidth+'" height="'+NXTreeSettings.treeIconHeight+'"/>';
  

  html += '<span id="NXTN-span-'+this.sId+'" class="NXTN_nodeLink">'
  html += this.sTitle;
  html += '</span>';


  html += '</div>';

  return html;
};

NXTreeNode.prototype.getNodeByTitle = function(sTitle)
{
  for (var i in this.aChildNodes)
  {
    if (!this.aChildNodes[i])
    {
      continue;
    }

    if (this.aChildNodes[i].sTitle.toLowerCase() == sTitle.toLowerCase())
    {
      return this.aChildNodes[i];
    }
  }
  return null;
}
/*****************************/
/* End NXTreeNode Prototypes */
/*****************************/


/*******************/
/* Begin Functions */
/*******************/
function getIconOpposite(iconActual,actualStatus,newStatus)
{
  Opposite = new Array();

  if (newStatus != 'disabled')
  {
    Opposite[NXTreeSettings.treeIconRootMinus] = (newStatus == 'plus' || newStatus == 'disabledPlus')   ? NXTreeSettings.treeIconRootPlus  : NXTreeSettings.treeIconRootMinus;
    Opposite[NXTreeSettings.treeIconRootPlus]  = (newStatus == 'minus' || newStatus == 'disabledMinus') ? NXTreeSettings.treeIconRootMinus : NXTreeSettings.treeIconRootPlus;
    Opposite[NXTreeSettings.treeIconTminus]    = (newStatus == 'plus' || newStatus == 'disabledPlus')   ? NXTreeSettings.treeIconTplus     : NXTreeSettings.treeIconTminus;
    Opposite[NXTreeSettings.treeIconTplus]     = (newStatus == 'minus' || newStatus == 'disabledMinus') ? NXTreeSettings.treeIconTminus    : NXTreeSettings.treeIconTplus;
    Opposite[NXTreeSettings.treeIconLminus]    = (newStatus == 'plus' || newStatus == 'disabledPlus')   ? NXTreeSettings.treeIconLplus     : NXTreeSettings.treeIconLminus;
    Opposite[NXTreeSettings.treeIconLplus]     = (newStatus == 'minus' || newStatus == 'disabledMinus') ? NXTreeSettings.treeIconLminus    : NXTreeSettings.treeIconLplus;
    Opposite[NXTreeSettings.treeIconBlank]     = (newStatus == 'plus' || newStatus == 'disabledPlus')   ? NXTreeSettings.treeIconRootPlus  : NXTreeSettings.treeIconRootMinus;
    Opposite[NXTreeSettings.treeIconTBlank]    = (newStatus == 'plus' || newStatus == 'disabledPlus')   ? NXTreeSettings.treeIconTplus     : NXTreeSettings.treeIconTminus;
    Opposite[NXTreeSettings.treeIconLBlank]    = (newStatus == 'plus' || newStatus == 'disabledPlus')   ? NXTreeSettings.treeIconLplus     : NXTreeSettings.treeIconLminus;
  }
  else
  {
    Opposite[NXTreeSettings.treeIconRootMinus] = NXTreeSettings.treeIconBlank;
    Opposite[NXTreeSettings.treeIconRootPlus]  = NXTreeSettings.treeIconBlank;
    Opposite[NXTreeSettings.treeIconTminus]    = NXTreeSettings.treeIconTBlank;
    Opposite[NXTreeSettings.treeIconTplus]     = NXTreeSettings.treeIconTBlank;
    Opposite[NXTreeSettings.treeIconLminus]    = NXTreeSettings.treeIconLBlank;
    Opposite[NXTreeSettings.treeIconLplus]     = NXTreeSettings.treeIconLBlank;
    Opposite[NXTreeSettings.treeIconBlank]     = NXTreeSettings.treeIconBlank;
    Opposite[NXTreeSettings.treeIconTBlank]    = NXTreeSettings.treeIconTBlank;
    Opposite[NXTreeSettings.treeIconLBlank]    = NXTreeSettings.treeIconLBlank;
  }

  iconOpposite = Opposite[iconActual];

  if (!iconOpposite || iconOpposite == '' || iconOpposite == null)
  {
   iconOpposite = iconActual.replace(actualStatus,newStatus);
  }

  return iconOpposite;
};

function getNodeById(sId,parentNode)
{
  var objNode = null;

  if (!parentNode || parentNode == null)
  {
    parentNode = globalRootNode;
  }

  if (!sId || sId == '0')
  {
    objNode = globalRootNode;
  }
  else
  {
    for (var i in parentNode.aChildNodes)
    {
      if (parentNode.aChildNodes[i].sId == sId)
      {
        return parentNode.aChildNodes[i];
      }
      if (parentNode.aChildNodes[i].aChildNodes.length)
      {
        objNode = getNodeById(sId,parentNode.aChildNodes[i]);
        if (objNode && objNode != null)
        {
          return objNode;
        }
      }
    }
  }

  return objNode;
}

function changeContent(tagId, content)
{
//alert("Here is the userAgent :" + navigator.userAgent);
  if (document.getElementById && navigator.userAgent.indexOf("Opera ") != -1)
  {
    var operaVersion;
    var tempVar =navigator.userAgent;
    operaVersion = tempVar.split("Opera");
    alert("Sorry, Tree menu not supported on your Opera " + operaVersion + " browser version.\n Download a newer version of Opera or try Firefox.");
  }
  else if (document.getElementById)
  {
    document.getElementById(tagId).innerHTML = content;
  }
  else if (document.layers)
  {
    // only supported for loading contents of a file into a layer
    // syntax: load(pathNfilename, width)
    document.layers[tagId].load(content, 300);
  }
  else if (document.all)
  {
    document.all[tagId].innerHTML = content;
  }
};

function changeRootIconsDisabled(sId,forceStatus)
{
  var nodeStatus = checkCookie(sId+'Status');
  nodeStatus = (!nodeStatus || nodeStatus == null) ? "disabledPlus" : nodeStatus;

  var newStatus = (nodeStatus == "disabledPlus") ? "disabledMinus" : "disabledPlus";
  newStatus = (forceStatus && forceStatus != null) ? forceStatus : newStatus;
  addCookie(sId+'Status',newStatus);

  var nodeImage = checkCookie(sId);
  var newIcon = getIconOpposite(nodeImage,nodeStatus,newStatus);
  addCookie(sId,newIcon);

  globalNXTree.display();
  ////alert(displayCounter + ". changeRootIconsDisabled sId = " + sId);  
};

function changeTreeIcons(sId,forceStatus)
{
  var objNode = getNodeById(sId);
  var nodeStatus = checkCookie(sId+'Status');
  nodeStatus = (!nodeStatus || nodeStatus == null) ? "plus" : nodeStatus;

  var newStatus = (nodeStatus == "plus") ? "minus" : "plus";
  newStatus = (forceStatus && forceStatus != null) ? forceStatus : newStatus;
  addCookie(sId+'Status',newStatus);

  var nodeImage = checkCookie(sId);
  if (!nodeImage){
    nodeImage="";
  }  
  var newIcon = getIconOpposite(nodeImage,nodeStatus,newStatus);

  addCookie(sId,newIcon);

  if (objNode.bHasChildren && !objNode.aChildNodes.length)
  {
    parent[objNode.sTarget].location = objNode.sUri;
  }

  globalNXTree.display();
};

function showChildren(childNodes)
{
  var html = '';
  var parentStatus = 'plus';
  for (var i in childNodes)
  {
    parentStatus = checkCookie(childNodes[i].oParentNode.sId+'Status');
    parentStatus = (!parentStatus || parentStatus == null) ? "plus" : parentStatus;
    if (parentStatus == 'minus' || parentStatus == 'disabledMinus')
    {
      html += createHtmlChild(childNodes[i]);
      if (childNodes[i].aChildNodes.length)
      {
        html += showChildren(childNodes[i].aChildNodes);
      }
    }
  }

  return html;
};

function createHtmlChild(child)
{
  var childStatus = checkCookie(child.sId+'Status');
  child.bDisabled = (childStatus == 'disabled') ? true : false;

  if (childStatus == 'minus' && !child.aChildNodes.length)
  {
    addCookie(child.sId+'Status',"plus");
    addCookie(child.sId,"");
  }

  var childIcon = checkCookie(child.sId);
  if (child.aChildNodes.length || child.bHasChildren)
  {
    if (child.bIsLast)
    {
      childIcon = (!childIcon || childIcon == null || childIcon == NXTreeSettings.treeIconLBlank) ? NXTreeSettings.treeIconLplus : childIcon;
      childIcon = (child.bDisabled) ? NXTreeSettings.treeIconLBlank : childIcon;
    }
    else
    {
      childIcon = (!childIcon || childIcon == null || childIcon == NXTreeSettings.treeIconTBlank) ? NXTreeSettings.treeIconTplus : childIcon;
      childIcon = (child.bDisabled) ? NXTreeSettings.treeIconTBlank : childIcon;
    }
    addCookie(child.sId,childIcon);
  }
  else
  {
    if (child.bIsLast)
    {
      childIcon = NXTreeSettings.treeIconL;
    }
    else
    {
      childIcon = NXTreeSettings.treeIconT;
    }
  }

  child.bFocus = (checkCookie("focusId") == child.sId) ? true : false;
  var childTitle = child.sTitle;
  if (child.bFocus)
  {
    childTitle = "<b>"+child.sTitle+"</b>";
  }

  var optionDisabled = checkCookie(child.sId+"Disabled");
  child.bLinkable = (optionDisabled == "linkable") ? true : false;

  var count = child.sId.split(".");
  var imgIndent = '';
  var indent = '';
  for (var i = 1; i < count.length; i++)
  {
    indent = NXTreeSettings.treeIconUriPath;

    if (count.length<4){ //count.length are the cols of the menu (images and strings)
	indent += ((i+1 == count.length) && !child.oParentNode.bIsLast) ? NXTreeSettings.treeIconI : NXTreeSettings.treeIconBlank;
    }

    else if (count.length>3){  //is opened users, sessions or statistics from the tree menu
     
      if ((child.oParentNode).oParentNode.bIsLast){ //last server in tree menu doesn't require i.gif for first two items
      if (i<3){ //i is the col
	  indent +=NXTreeSettings.treeIconBlank;
	}
	else {
	 is_last_group = child.oParentNode.bIsLast;
	 if (is_last_group){ // fix me
	  indent +=NXTreeSettings.treeIconBlank;	 
	 }
	 else {
          indent +=NXTreeSettings.treeIconI;
	 } 	
	}
      }
      else{ // this server isn't last one in the tree menu, it requires empty.gif for first item and i.gif for the last 3 items
	if (i==1){ 	  //if last one item doesn't have child => ((i==1) || child.oParentNode.bIsLast)
	  indent +=NXTreeSettings.treeIconBlank;	
	}
	else{
	  indent +=NXTreeSettings.treeIconI;
	}
      }
    }
    imgIndent += '<img id="Indent-'+child.sId+'-'+i+'" ';
    imgIndent += 'class="tree-ident" ';
    imgIndent += 'src="'+indent+'" ';
    imgIndent += ' width="'+NXTreeSettings.treeIconWidth+'" height="'+NXTreeSettings.treeIconHeight+'"/>';
  }

  var htmlTitle = '';
  var sIcon = child.sIcon;

  if (child.bDisabled && !child.bLinkable)
  {
    htmlTitle  = '<span id="NXTN-span-'+child.sId+'" class="NXTN_nodeLink">'
    htmlTitle += childTitle;
    htmlTitle += '</span>';
    sIcon = child.sIconDisabled;
    child.bDisabled = true;
    addCookie(child.sId+'Status','disabled');
  }
  else
  {
    htmlTitle  = '<a id="link-'+child.sId+'" class="NXTN_nodeLink" ';
    htmlTitle += 'href="'+child.sUri+'" ';
    htmlTitle += 'target="'+child.sTarget+'" ';
//  htmlTitle += 'title="'+child.sDesc+'">';	//add this line to show tooltip
    htmlTitle += '>';	//remove this line to show tooltips
    htmlTitle += childTitle;
    htmlTitle += '</a>';
    child.bDisabled = false;
  }

  var html = '';

  var divClass = (child.bFocus) ? '_focus' : '';
  divClass = (child.bDisabled) ? '_disabled' : divClass;

  html += '<div id="NXTreeNode" class="NXTN_node'+divClass+'">';

  html += imgIndent;

  html += '<img id="'+child.sId+'" class="NXTN_treeIcon"';
  html += 'src="'+NXTreeSettings.treeIconUriPath+''+childIcon+'" ';
  html += 'width="'+NXTreeSettings.treeIconWidth+'" height="'+NXTreeSettings.treeIconHeight+'"';

  if (!child.bDisabled)
  {
    html += ' onclick="changeTreeIcons(this.id)"';
  }
  html += '/>';

  html += '<img id="NXTN-img-1-nodeIcon" class="NXTN_nodeIcon"';
  html += 'src="'+NXTreeSettings.nodeIconUriPath+''+sIcon+'" ';
  html += 'width="'+NXTreeSettings.treeIconWidth+'" height="'+NXTreeSettings.treeIconHeight+'"/>';

  html += htmlTitle;

  html += '</div>';

  return html;
}
/*****************/
/* End Functions */
/*****************/

/******************************/
/* Functions to handle cookies*/
/******************************/
function addCookie(key,cookieValue){
globalCookie = getCookie('menu');
if (globalCookie){  
  var index = globalCookie.indexOf(key + "=");
  if (index == -1)
  {
    globalCookie = globalCookie + key + "=" + cookieValue + "; ";
  }
  else{
  var oldGlobalCookie = globalCookie;
  var Cookie_beforeInsert = unescape(oldGlobalCookie.substr(0,index)); 
  index = oldGlobalCookie.indexOf("=", index) + 1;
  var endstr = globalCookie.indexOf(";", index);

  if (endstr == -1)
  {
    endstr = globalCookie.length;
  }
  var Cookie_afterInsert = unescape(oldGlobalCookie.substring(endstr,oldGlobalCookie.length)); 
  globalCookie = Cookie_beforeInsert + key + "=" + cookieValue + Cookie_afterInsert; //Cookie_afterInsert already start with ;
  }
}
else {
 globalCookie = key + "=" + cookieValue + "; ";
 }
setCookie('menu',globalCookie);
}

function clearUselessCookies(){
globalCookie = getCookie('menu');
number_of_connected_servers = parent.menuFrame.menuServer.length;

if (globalCookie){ //in menu: menuServer 2 is the first NX Server Item
 
  server_number = parent.menuFrame.menuServer.length+2;
  var index = globalCookie.indexOf(" 0." + server_number);
  if (index == -1)
  { //if there isn't 0.server_number, find last item of previous server 
    index = globalCookie.lastIndexOf(" 0." + server_number-1);
    index = globalCookie.indexOf(";", index) + 1;
  }
  var oldGlobalCookie = globalCookie;
  var Cookie_beforeInsert = unescape(oldGlobalCookie.substr(0,index)); 
  //index = oldGlobalCookie.indexOf(" 0." + server_number, index) + 1;  
  
  // last occurs, check if the value are progressive
//  var lastOccur = globalCookie.lastIndexOf(" 0." + server_number);
//  if ((lastOccur == index) || (lastOccur == -1)){
//    var endstr = globalCookie.indexOf("; ", index) + 1;  
//  }
//  else{
//    var endstr = globalCookie.indexOf("; ", lastOccur) + 1;    
//  }

//  if (endstr == -1)
//  {
//    endstr = globalCookie.length;
//  var Cookie_afterInsert = unescape(oldGlobalCookie.substring(endstr,oldGlobalCookie.length)); 
//  globalCookie = Cookie_beforeInsert + Cookie_afterInsert; //Cookie_afterInsert already start with ;
  globalCookie = Cookie_beforeInsert; //Cookie_afterInsert already start with ;  
  if (parent.menuFrame.menuServer.length == 0){
    //addcookie("0.1",
  }
  }
//  alert(globalCookie);
//}
else {
 globalCookie = "";
 }
setCookie('menu',globalCookie);
}

function checkCookie(key){
  var source;
  var res;
  if (getCookie('menu') == null){
  source = globalCookie;
  }
  else if (getCookie('menu') == ''){
  source = globalCookie;
  }
  else{
  source = getCookie('menu');
  globalCookie =  source; 
  }


  var index = source.indexOf(key + "=");
  if (index == -1)
  {
    var res;
    return res;
  }
  else{

  index = source.indexOf("=", index) + 1;
  var endstr = source.indexOf(";", index);

  if (endstr == -1)
  {
    endstr = source.length;
  }
  var res = unescape(source.substring(index,endstr));
  }
  return (res);
}
/**********************************/
/* End Functions to handle cookies*/
/**********************************/

/**************************/
/* Begin Cookie functions */
/**************************/
function setCookie(key, value)
{
  var today  = new Date();
  //var expires = new Date(today.getTime() + 28 * 24 * 60 * 60 * 1000); // plus 28 days
  //document.cookie = key + "=" + escape(value) + "; expires=" + expires.toGMTString();
  document.cookie = key + "=" + escape(value) + "; expires=";  
}


function getCookie(key)
{
  var index = document.cookie.indexOf(key + "=");

  if (index == -1)
  {
    return null;
  }

  index = document.cookie.indexOf("=", index) + 1;
  var endstr = document.cookie.indexOf(";", index);

  if (endstr == -1)
  {
    endstr = document.cookie.length;
  }

  var cokValue = unescape(document.cookie.substring(index, endstr));
  cokValue = (cokValue == "") ? null : cokValue;

  return cokValue;
}
/************************/
/* End Cookie functions */
/************************/


/*******************************************/
/* Functions to handle Server Items in Menu*/
/*******************************************/
function DeleteServerFromMenu(workingNXServerName){

  for (i=0; i<=parent.menuFrame.menuServer.length; i++){
   
    if (parent.menuFrame.menuServer[i].sTitle == workingNXServerName){        
      //alert("server " +i + " -> " + parent.menuFrame.menuServer[i].sTitle);
      
      
      //parent.menuFrame.menuServer[i].disableAllChildren();
      parent.menuFrame.menuServer[i].aChildNodes = null;
      parent.menuFrame.menuServer[i].aChildNodes = [];
      globalNXTree.display();
      
      var bodyId = document.getElementById("menu_javascript");
      var NXManagerTreeId = document.getElementById("NXManagerTree");
       
      i=i+2;
      
      delete NXManagerTreeId.childNodes[i];
    
    }
  }
 
}


// This function is used only to add the server name in the Menu
// it is called before login procedure
function AddOnlyServerNameInMenu(workingNXServerHost,workingNXServerName){
  menuServer[menuCounter] = new NXTreeNode(
     workingNXServerName, //workingNXServerHost
     '?page=body&action=showServer&nxserver='+workingNXServerHost, /*+'&sessID='+currentSessionID,*/
     'node1.gif',
     'node1.gif',
     'NX Server',
     '',
     'node1_dsb.gif');
  menuRoot.addChild(menuServer[menuCounter]);
  menuServer[menuCounter].bHasChildren = false;
 

menuCounter++;

}


// This function is used to add all the server information in the Menu
// it isn't called before login procedure
// it is called after logout procedure to add connected servers into the Menu
function AddServerInMenu(workingNXServerHost,workingNXServerName, server_version){
  // NXTreeNode(sTitle, sUri, sIcon, sIconOpen, sDesc, sTarget)
  // menuServer = new NXTreeNode('NX Server [Sole]', '?page=body&action=showServer&nxserver=sole', 'node1.gif', 'node1.gif', 'NXServer [Sole]', '');
  menuServer[menuCounter] = new NXTreeNode(
     workingNXServerName, //workingNXServerHost
     '?page=body&action=showServer&nxserver='+workingNXServerHost, /*+'&sessID='+currentSessionID,*/
     'node1.gif',
     'node1.gif',
     'NX Server',
     '',
     'node1_dsb.gif');
  menuRoot.addChild(menuServer[menuCounter]);

  menuUsers[menuCounter] = new NXTreeNode(
     'Users',
     '?page=body&action=userList&nxserver='+workingNXServerHost, /*+'&sessID='+currentSessionID,*/
     'users1.gif',
     'users2.gif',
     'Users',
     'bodyFrame');
  menuUsers[menuCounter].bHasChildren = true;
  menuServer[menuCounter].addChild(menuUsers[menuCounter]);

  userPrevPage[menuCounter] = new NXTreeNode(
     'Prev',
     '/nxmanager/blank.html',
     'userPrev.gif',
     'userPrev.gif',
     'Go to previous user page');

  userNextPage[menuCounter] = new NXTreeNode(
     'Next',
     '/nxmanager/blank.html',
     'userNext.gif',
     'userNext.gif',
     'Go to next user page');


  menuProfiles[menuCounter] = new NXTreeNode(
     'System profile',
     '?page=body&action=confNXProfiles&user=NXSystemUserProfileName&nxserver='+workingNXServerHost,
     'system_profile.png',
     'system_profile.png',
     'System profile',
     'bodyFrame');
  //menuProfiles[selected_server].bHasChildren = false;
  //parent.menuFrame.menuServer[selected_server].addChild(menuProfiles[menuCounter]);
     menuProfiles[menuCounter].bHasChildren = false;
     menuServer[menuCounter].addChild(menuProfiles[menuCounter]);

/*
  profilePrevPage[menuCounter] = new NXTreeNode(
     'Prev',
     '/nxmanager/blank.html',
     'userPrev.gif',
     'userPrev.gif',
     'Go to previous profile page');
  // menuProfiles.addChild(profilePrevPage);

  profileNextPage[menuCounter] = new NXTreeNode(
     'Next',
     '/nxmanager/blank.html',
     'userNext.gif',
     'userNext.gif',
     'Go to next profile page');
  // menuProfiles.addChild(profileNextPage);
*/

  menuSessions[menuCounter] = new NXTreeNode(
     'Sessions',
     '?page=body&action=sessionList&nxserver='+workingNXServerHost,
     'sessions1.gif',
     'sessions2.gif',
     'Sessions',
     'bodyFrame');
  menuSessions[menuCounter].bHasChildren = true;
  menuServer[menuCounter].addChild(menuSessions[menuCounter]);

  sessionPrevPage[menuCounter] = new NXTreeNode(
     'Prev',
     '/nxmanager/blank.html',
     'sessionPrev.gif',
     'sessionPrev.gif',
     'Go to previous session page');

  sessionNextPage[menuCounter] = new NXTreeNode(
     'Next',
     '/nxmanager/blank.html',
     'sessionNext.gif',
     'sessionNext.gif',
     'Go to next session page');

  menuNodes[menuCounter] = new NXTreeNode(
     'Nodes',
     '?page=body&action=nodeList&nxserver='+workingNXServerHost,
     'nodes.gif',
     'nodes.gif',
     'Nodes',
     'bodyFrame');
  menuNodes[menuCounter].bHasChildren = true;
  parent.menuFrame.menuServer[menuCounter].addChild(menuNodes[menuCounter]);

  nodePrevPage[menuCounter] = new NXTreeNode(
     'Prev',
     '/nxmanager/blank.html',
     'sessionPrev.gif',
     'sessionPrev.gif',
     'Go to previous node page');

  nodeNextPage[menuCounter] = new NXTreeNode(
     'Next',
     '/nxmanager/blank.html',
     'nodeNext.gif',
     'nodeNext.gif',
     'Go to next node page');

  menuStatistics[menuCounter] = new NXTreeNode(
     'Statistics',
     '?page=body&action=statistics&nxserver='+workingNXServerHost,
     'statistics1.gif',
     'statistics2.gif',
     'Statistics',
     'bodyFrame');
  menuStatistics[menuCounter].bHasChildren = true;
  menuServer[menuCounter].addChild(menuStatistics[menuCounter]);


  menuConfServer[menuCounter] = new NXTreeNode(
     'Configurations',
     '?page=body&action=confNXServer&nxserver='+workingNXServerHost,
     'configuration1.gif',
     'configuration2.gif',
     'Configurations',
     'bodyFrame');
  menuConfServer[menuCounter].bHasChildren = true;
  menuServer[menuCounter].addChild( menuConfServer[menuCounter] ); 
   
  menuConfNXServer[menuCounter] = new NXTreeNode(
     'Server',
     '?page=body&action=confNXServer&nxserver='+workingNXServerHost,
     'confnxserver.gif',
     'confnxserver.gif',
     'Configurations',
     'bodyFrame');
  menuConfServer[menuCounter].addChild( menuConfNXServer[menuCounter] ); 

//  if(server_version != 1){
//  menuConfNXNode[menuCounter] = new NXTreeNode(
//     'Node',
//     '?page=body&action=confNXNode&nxserver='+workingNXServerHost,
//     'nodes.gif',
//     'nodes.gif',
//     'Configurations',
//     'bodyFrame');
//  menuConfServer[menuCounter].addChild( menuConfNXNode[menuCounter] ); 
//  }
 
  menuServer[menuCounter].bHasChildren = true;
  menuCounter++;
}

/***********************************************/
/* End Functions to handle Server Items in Menu*/
/***********************************************/

