/**************************************************************************/
/*                                                                        */
/* Copyright (c) 2001, 2011 NoMachine, http://www.nomachine.com/.         */
/*                                                                        */
/* NXMANAGER, NX protocol compression and NX extensions to this software  */
/* are copyright of NoMachine. Redistribution and use of the present      */
/* software is allowed according to terms specified in the file LICENSE   */
/* which comes in the source distribution.                                */
/*                                                                        */
/* Check http://www.nomachine.com/licensing.html for applicability.       */
/*                                                                        */
/* NX and NoMachine are trademarks of Medialogic S.p.A.                   */
/*                                                                        */
/* All rights reserved.                                                   */
/*                                                                        */
/**************************************************************************/

//function used to delete the HTML code of the menu
function destroyMenuTree(){
delete oNXTree;
}

//function used to create menuRoot and NXManager nodes (statics)
function createMenuTree(not_guest){
  oNXTree = new NXTree;

  menuRoot = new NXTreeNode(
    'The NX Network',
    '', //'?page=body&action=showNXNetwork',
    'home.gif',
    'home.gif',
    'NX Network',
    'bodyFrame',
    'home_dsb.gif');
  oNXTree.setRootNode( menuRoot );

 ////////////////////////////////////////
 // NX Manager nodes
 ////////////////////////////////////////

  menuNXManager = new NXTreeNode(
     workingNXManagerName,
     '?page=body&action=showManager',
     'nxmanager.gif',
     'nxmanager.gif',
     'NX Server Manager',
     'bodyFrame',
     'nxmanager_dsb.gif');
  menuRoot.addChild(menuNXManager);
  
  menuConfManagerServers = new NXTreeNode(   //'confnxserver.gif'
     'Servers',
     '?page=body&action=confManagerServers',
     'confnxserver.gif',
     'confnxserver.gif',
     'NX server list',
     'bodyFrame');
  menuNXManager.addChild( menuConfManagerServers  );
  
  if (not_guest == 'true'){
  menuConfManagerUsers = new NXTreeNode(
     'Managers',
     '?page=body&action=confManagerUsers',
     'nxmanagerusers.gif',
     'nxmanagerusers.gif',
     'Managers of NX Server Manager',
     'bodyFrame');
  menuNXManager.addChild( menuConfManagerUsers  );

  menuConfManagerOptions = new NXTreeNode(
     'Restrictions',
     '?page=body&action=confManagerOptions',
     'nxmanageroptions.gif',
     'nxmanageroptions.gif',
     'Restrictions of NX Server Manager',
     'bodyFrame');
  menuNXManager.addChild( menuConfManagerOptions  );
  }
}

 ///////////////////////
 // NX Server nodes   //               
 ///////////////////////
 //this function is used to add server items in the menu
 //checking if server name is already present in list or not
function returnNXServersName(connected_servers, server_name, server_version, server_port){ 
//version in required to correctly display configuration child items in menu

var serverList = connected_servers.split(";");
var serverList_name    = server_name.split(";");
var serverList_version = server_version.split(";");
var serverList_port    = server_port.split(";");

for (i=0; i<serverList.length-1; i++){
  var server_already_present_in_list = 0;
  for(j=0; j<parent.menuFrame.menuServer.length;j++){
    if (serverList_name[i] == parent.menuFrame.menuServer[j].sTitle){
      server_already_present_in_list = 1;
   
      if (parent.menuFrame.menuServer[j].bHasChildren == false){

	if (!server_port){ //only in confManagerServers page there is a value in server_port
	  addServerItemsInMenu(j,serverList[i],serverList_version[i]);
       }
      }
      break;
    }
  }  

    if (server_already_present_in_list == 0){
      AddOnlyServerNameInMenu(serverList[i],serverList_name[i],serverList_version[i],serverList_port[i]);
    }
  }
}


 //this function is used to add server items in the menu
 //it's called after login procedure 
 //and after AddOnlyServerNameInMenu or after returnNXServersName
function addServerItemsInMenu(selected_server, workingNXServerHost, server_version)
{
  parent.menuFrame.menuServer[selected_server].bHasChildren = true;
  menuUsers[selected_server] = new NXTreeNode(
     'Users',
     '?page=body&action=userList&nxserver='+workingNXServerHost, /*+'&sessID='+currentSessionID,*/
     'users1.gif',
     'users2.gif',
     'Users',
     'bodyFrame');
  menuUsers[selected_server].bHasChildren = true;
  parent.menuFrame.menuServer[selected_server].addChild(menuUsers[selected_server]);

//  userLoading = new NXTreeNode(
//     'Loading...',
//     '/nxmanager/blank.html',
//    'arrows_users.gif',
//     'arrows_users.gif',
//     'The NXManager is loading users data.',
//     'bodyFrame');
  //menuUsers.addChild( userLoading );

  userPrevPage[selected_server] = new NXTreeNode(
     'Prev',
     '/nxmanager/blank.html',
     'userPrev.gif',
     'userPrev.gif',
     'Go to previous user page');
  // menuUsers.addChild(userPrevPage);

  userNextPage[selected_server] = new NXTreeNode(
     'Next',
     '/nxmanager/blank.html',
     'userNext.gif',
     'userNext.gif',
     'Go to next user page');
  // menuUsers.addChild(userNextPage);

  menuProfiles[selected_server] = new NXTreeNode(
     'System profile',
     '?page=body&action=confNXProfiles&user=NXSystemUserProfileName&nxserver='+workingNXServerHost,  //when page template profileList will be ready
     'system_profile.png',
     'system_profile.png',
     'System profile',
     'bodyFrame');
  menuProfiles[selected_server].bHasChildren = false;
  parent.menuFrame.menuServer[selected_server].addChild(menuProfiles[selected_server]);

/*
  profilePrevPage[selected_server] = new NXTreeNode(
     'Prev',
     '/nxmanager/blank.html',
     'userPrev.gif',
     'userPrev.gif',
     'Go to previous profile page');
  // menuProfiles.addChild(profilePrevPage);

  profileNextPage[selected_server] = new NXTreeNode(
     'Next',
     '/nxmanager/blank.html',
     'userNext.gif',
     'userNext.gif',
     'Go to next profile page');
  // menuProfiles.addChild(profileNextPage);
*/

  menuSessions[selected_server] = new NXTreeNode(
     'Sessions',
     '?page=body&action=sessionList&nxserver='+workingNXServerHost,
     'sessions1.gif',
     'sessions2.gif',
     'Sessions',
     'bodyFrame');
  menuSessions[selected_server].bHasChildren = true;
  parent.menuFrame.menuServer[selected_server].addChild(menuSessions[selected_server]);

  sessionPrevPage[selected_server] = new NXTreeNode(
     'Prev',
     '/nxmanager/blank.html',
     'sessionPrev.gif',
     'sessionPrev.gif',
     'Go to previous session page');
  // menuSessions.addChild(sessionPrevPage);

  sessionNextPage[selected_server] = new NXTreeNode(
     'Next',
     '/nxmanager/blank.html',
     'sessionNext.gif',
     'sessionNext.gif',
     'Go to next session page');
  // menuSessions.addChild(sessionNextPage);

  menuNodes[selected_server] = new NXTreeNode(
     'Nodes',
     '?page=body&action=nodeList&nxserver='+workingNXServerHost,
     'nodes.gif',
     'nodes.gif',
     'Nodes',
     'bodyFrame');
  menuNodes[selected_server].bHasChildren = true;
  parent.menuFrame.menuServer[selected_server].addChild(menuNodes[selected_server]);

  nodePrevPage[selected_server] = new NXTreeNode(
     'Prev',
     '/nxmanager/blank.html',
     'nodePrev.gif',
     'nodePrev.gif',
     'Go to previous node page');
  // menuNodes.addChild(nodePrevPage);

  nodeNextPage[selected_server] = new NXTreeNode(
     'Next',
     '/nxmanager/blank.html',
     'nodeNext.gif',
     'nodeNext.gif',
     'Go to next node page');
  // menuNodes.addChild(nodeNextPage);

  menuStatistics[selected_server] = new NXTreeNode(
     'Statistics',
     '?page=body&action=statistics&nxserver='+workingNXServerHost,
     'statistics1.gif',
     'statistics2.gif',
     'Statistics',
     'bodyFrame');
  menuStatistics[selected_server].bHasChildren = true;
  parent.menuFrame.menuServer[selected_server].addChild(menuStatistics[selected_server]);


  menuConfServer[selected_server] = new NXTreeNode(
     'Configurations',
     '?page=body&action=confNXServer&nxserver='+workingNXServerHost,
     'configuration1.gif',
     'configuration2.gif',
     'Configurations',
     'bodyFrame');
  menuConfServer[selected_server].bHasChildren = true;   
  parent.menuFrame.menuServer[selected_server].addChild( menuConfServer[selected_server] );
  
  menuConfNXServer[selected_server] = new NXTreeNode(
     'Server',
     '?page=body&action=confNXServer&nxserver='+workingNXServerHost,
     'confnxserver.gif',
     'confnxserver.gif',
     'Server',
     'bodyFrame');
  parent.menuFrame.menuConfServer[selected_server].addChild( menuConfNXServer[selected_server] );

// if (server_version != 1){
//  menuConfNXNode[selected_server] = new NXTreeNode(
//     'Node',
//     '?page=body&action=confNXNode&nxserver='+workingNXServerHost,
//     'nodes.gif',
//     'nodes.gif',
//     'Node',
//     'bodyFrame');
//  parent.menuFrame.menuConfServer[selected_server].addChild( menuConfNXNode[selected_server] );
// }
  
 
}
